unit UCollecVoiture;

{$mode ObjFPC}{$H+}

interface

uses
  Classes, SysUtils, UVoiture;

TYPE
  //tableau dynmaique de voitures
  TTabVoiture = array of TVoiture;

  //classe de gestion de collection de voitures
  { TCollecVoitures }
  TCollecVoitures = class
    //champ interne collection de tableau de voitures
    liste: TTabVoiture;
    //méthodes
    constructor create();//constructeur
    destructor destroy(); override;//destructeur
    procedure ajout(v: TVoiture);//ajouter une voiture dans la collection
    procedure affichage();//affichage de la collection
    function SommeTaxes(): double;//somme des taxes des véhicules
  end;

implementation

{ TCollecVoitures }

constructor TCollecVoitures.create;
begin
  inherited create();
  setlength(self.liste,0);//tableau vide pour l'instant
end;

destructor TCollecVoitures.destroy;
var i: integer;
begin
  //suppression des "pointeurs" de voitures
  for i:= 0 to length(self.liste)-1 do self.liste[i].free();
  //suppression de la liste interne
  Finalize(self.liste);
  inherited destroy;
end;

procedure TCollecVoitures.ajout(v: TVoiture);
var n: integer;
begin
  n:= length(self.liste); //longueur actuelle du tableau
  setLength(self.liste,n+1);//redimensionner le tableau
  self.liste[n]:= v;//au dernier indice
end;

procedure TCollecVoitures.affichage;
var i: integer;
    v: TVoiture;
begin
 writeln('Affichage de la liste des vehicules :');
 //itérer sur chaque voiture
 for i:= 0 to length(self.liste)-1 do
  begin
   v:= self.liste[i];//récupération de la voiture
   writeln('**');
   v.affichage();//le polymorphisme joue à fond ici
  end;
end;

function TCollecVoitures.SommeTaxes: double;
var i: integer;
    somme: double;
begin
 somme:= 0.0;
 for i:= 0 to length(self.liste)-1 do
   somme:= somme + self.liste[i].taxe();//polymorphisme à donf ici
 result:= somme;
end;

end.

